//  The Getaway!  Aug/Sep entry to IRTC   (c)1997 Rich Allen

global_settings {assumed_gamma 1.2 max_trace_level 10}

camera {
   location  <0.5, 2.0, -14.0>
   direction 1.5*z
   right     4/3*x
   look_at   <0.0, 1.8, 0.0>
}

light_source { <300,600,-300> color rgb 1 }
light_source { <0,2,-4.7> color rgb 1 fade_distance 5 fade_power 2 }

sky_sphere {
   pigment {
      gradient y
      turbulence .75
      color_map {
         [0.25 color rgb < 0,.3,.6> ]
         [0.47 color rgb <.7,.7,.7> ]
         [0.53 color rgb <.7,.7,.7> ]
         [0.75 color rgb < 0,.3,.6> ]
      }
      scale <1,.2,1>
   }
}

#include "ground.inc"

#include "mountains.inc"

#declare NTrees = 150
#declare TDepth = 100
#include "tree.inc"

#declare NShrubs = 500
#declare SDepth = 500
#include "shrub.inc"

#include "crystals.inc"

#include "gate.inc"

#include "staff.inc"

#include "dragon.inc"

#include "egg.inc"
